package whilelang

object Main {
  def main(args : Array[String]) : Unit = {
    if(args.length != 1) {
      Error("Please provide an input file.")
    }

    import java.io.{FileInputStream,IOException}

    val parser = new Parser

    try {
      val in = new FileInputStream(args(0))
      val parsed = parser.parseInputStream(in)

      println("Original program:")
      println("*****************\n")
      TreePrinter(parsed)


      val unrolled = Unrolling.unroll(parsed, 3)
      println("Unrolled program:")
      println("*****************\n")
      TreePrinter(unrolled)

    } catch {
      case e: IOException => Error(e.getMessage)
    }
  }
}
